Date: Mon, 15 Mar 2010 14:04:59 -0400
Mime-Version: 1.0 (Produced by PhpWiki 1.6.6)
Content-Type: application/x-phpwiki;
  pagename=KnowledgeBase%2FScripts%2Fchroot_bin.sh;
  author=CyberLeo;
  owner=CyberLeo;
  version=5;
  lastmodified=1268676299;
  created=1268676299;
  author_id=CyberLeo;
  hits=1564;
  charset=UTF-8
Content-Transfer-Encoding: binary

<code brush="bash">
case "$(uname -s)" in
Linux)
  libscan() {
    [ "${1}" ] || return 1
    (
     echo /lib/ld-linux.so.2
     while [ "${1}" ]
     do
       if [ -x "${1}" ]
       then
	 ldd "${1}" | sed -e '/ => /!d; s/^.* => //; s/ (0x[0-9a-f]*)$//; /^[     ]*$/d'
       fi
       shift
     done
    ) | sort | uniq
  }
  populate_chroot() {
    dest="${1}"; shift
    bins="${@}"
    libs="$(libscan "${@}")"
    temp="$(mktemp -d "${dest}/.chroot.XXXXXXXX")"
    [ -d "${temp}" ] || return 1
    cp -p ${bins} ${libs} ${temp}/
    echo "$(basename "${temp}")"
  }
  chroot_bin() {
    tgt="${1}"; shift
    bin="$(which "${1}")"; shift
    [ -d "${tgt}" -a -x "${bin}" ] || return 1
    tmp="$(populate_chroot "${tgt}" "${bin}")"
    exe="$(basename "${bin}")"
    ( sleep 0.1; rm -Rf "${tgt}/${tmp}" ) &
    LD_LIBRARY_PATH="/${tmp}/" /usr/bin/chroot "${tgt}" "/${tmp}/ld-linux.so.2" "/${tmp}/${exe}" "${@}"
  }
  ;;
FreeBSD)
  libscan() {
    [ "${1}" ] || return 1
    (
      echo "/libexec/ld-elf.so.1"
      while [ "${1}" ]
      do
	if [ -x "${1}" ]
	then
          ldd "${1}" | sed -e '/ => /!d; s/^.* => //; s/ (0x[0-9a-f]*)$//; /^[     ]*$/d'
	fi
	shift
      done
    ) | sort | uniq
  }
  populate_chroot() {
    dest="${1}"; shift
    bins="${@}"
    libs="$(libscan "${@}")"
    temp="$(mktemp -d "/tmp/.chroot.XXXXXXXX")"
    [ -d "${temp}" ] || return 1
    mkdir -p "${temp}/.run"
    cp -p ${bins} ${libs} "${temp}/.run/"
    mkdir -p "${temp}/libexec"
    ln -f "${temp}/.run/ld-elf.so.1" "${temp}/libexec/"
    echo "${temp}"
  }
  chroot_bin() {
    tgt="${1}"; shift
    bin="$(which "${1}")"; shift
    [ -d "${tgt}" -a -x "${bin}" ] || return 1
    tmp="$(populate_chroot "${tgt}" "${bin}")"
    exe="$(basename "${bin}")"
    mount -t unionfs "${tmp}" "${tgt}"
    ( sleep 0.1; umount -f "${tgt}"; rm -Rf "${tmp}" ) &
    LD_LIBRARY_PATH="/.run" /usr/sbin/chroot "${tgt}" "/.run/${exe}" "${@}"
  }
  ;;
esac
</code>
