Date: Tue, 23 Feb 2010 05:59:42 -0500
Mime-Version: 1.0 (Produced by PhpWiki 1.6.6)
Content-Type: application/x-phpwiki;
  pagename=KnowledgeBase%2FScripts%2Fdiskstats.sh;
  author=CyberLeo;
  owner=CyberLeo;
  version=8;
  lastmodified=1266922782;
  created=1266922782;
  author_id=CyberLeo;
  hits=2529;
  charset=UTF-8
Content-Transfer-Encoding: binary

<code brush="bash">
#!/bin/bash

# Digest a single number into a pretty number
pretty(){
  # Initialization
  num=${1:-0}
  zero=0
  tera_mag=1099511627776
  giga_mag=1073741824
  mega_mag=1048576
  kilo_mag=1024
  byte_mag=1

  # Scale down to appropriate magnitude
  tera=$(( $num / ${tera_mag} ))
  num=$(( $num % ${tera_mag} ))
  giga=$(( $num / ${giga_mag} ))
  num=$(( $num % ${giga_mag} ))
  mega=$(( $num / ${mega_mag} ))
  num=$(( $num % ${mega_mag} ))
  kilo=$(( $num / ${kilo_mag} ))
  num=$(( $num % ${kilo_mag} ))
  byte=${num:-0}

  # Select proper magnitude and suffix
  one=byte && two=zero && sign=B
  [ $kilo -gt 0 ] && one=kilo && two=byte && suffix=kB
  [ $mega -gt 0 ] && one=mega && two=kilo && suffix=MB
  [ $giga -gt 0 ] && one=giga && two=mega && suffix=GB
  [ $tera -gt 0 ] && one=tera && two=giga && suffix=TB

  # Compute float
  whole=$(eval echo \$$one)
  part=$(eval echo \$$two)
  num=$(printf "%s.%s" "${whole}" "${part}")

  # Compute printf format
  fmt="%0.2f%s\n"
  [ "${whole}" -gt 9 ] && fmt="%0.1f%s\n"
  [ "${whole}" -gt 99 ] && fmt="%0.0f%s\n"
  [ "${two}" = "zero" ] && fmt="%0.0f%s\n"

  # Generate result
  printf "${fmt}" "${num}" "${suffix}"
}

digest(){
  dev="${1}"
  if [ ! -d "/sys/block/${dev}" ]
  then
    return 1
  fi
  eval $(printf 'old_r=$old_r_%s old_w=$old_w_%s' "${dev}" "${dev}")
  [ -z "${old_r}" ] && old_r=0
  [ -z "${old_w}" ] && old_w=0
  eval $(awk '{print "cur_r=" $3 " cur_w=" $7}' /sys/block/${dev}/stat)
  dif_r=$(( (${cur_r} - ${old_r}) * 512 ))
  dif_w=$(( (${cur_w} - ${old_w}) * 512 ))
  eval $(printf "old_r_%s=%u old_w_%s=%u" "${dev}" "${cur_r}" "${dev}" "${cur_w}")
  printf "%s: R: %s W: %s \033[K\n" "${dev}" "$(pretty ${dif_r})" "$(pretty ${dif_w})"
}

while true
do
  printf "\033[0;0H" # Cursor to upper left
  for I in /sys/block/sd?
  do
    digest "$(basename "${I}")"
  done
  printf "\033[0J" # Clear the rest of the page
  sleep 1
done

</code>
