Date: Sun, 3 Oct 2010 03:43:56 -0400
Mime-Version: 1.0 (Produced by PhpWiki 1.6.6)
Content-Type: application/x-phpwiki;
  pagename=KnowledgeBase%2FScripts%2Flonglines.sh;
  author=CyberLeo;
  owner=CyberLeo;
  version=5;
  lastmodified=1286091836;
  created=1286091836;
  author_id=CyberLeo;
  hits=1600;
  charset=UTF-8
Content-Transfer-Encoding: binary

This will translate a file that consists of backslash-newline broken lines into a file with single long lines, and squash whitespace.

For example:
<code>
acpi_quirks.h                   optional acpi                              \
        dependency      "$S/tools/acpi_quirks2h.awk $S/dev/acpica/acpi_quirks" \
        compile-with    "${AWK} -f $S/tools/acpi_quirks2h.awk $S/dev/acpica/acpi_quirks" \
        no-obj no-implicit-rule before-depend                              \
        clean           "acpi_quirks.h"
</code>
becomes
<code>
acpi_quirks.h optional acpi dependency "$S/tools/acpi_quirks2h.awk $S/dev/acpica/acpi_quirks" compile-with "${AWK} -f $S/tools/acpi_quirks2h.awk $S/dev/acpica/acpi_quirks" no-obj no-implicit-rule before-depend clean "acpi_quirks.h"
</code>

<code brush="bash">
expand "${file}" | sed -ne '
s/#.*$//g     # Strip out all comments, as they may interfere
s/ *$//       # Remove end-of-line whitespace
/[^\\]$/ {    # If the line doesn't end with a backslash, print the whole thing
  H           # Append current line to hold
  s/.*//g     # Clear pattern so that hold will be emptied
  x           # Exchange (hold is empty, pattern has what we want)
  s/^\n//g    # Remove initial newline, caused by appending to empty buffer
  s/\n/ /g    # Change newlines to spaces
  s/  */ /g   # Squash extra spaces
  p           # Print
}
/\\$/ {       # If the line ends with a backslash, append it to hold without backslash
  s/\\$//     # Remove tailing backslash
  H           # Append to hold
}'
</code>
